AbstractChart (base API)
Date: 2019-04-05

com.twosigma.beakerx.chart

## Class AbstractChart

- java.lang.Object
- - com.twosigma.beakerx.widget.Widget
  - - com.twosigma.beakerx.widget.BeakerxWidget
    - - com.twosigma.beakerx.chart.ChartDetails
      - - com.twosigma.beakerx.chart.Chart
        - - com.twosigma.beakerx.chart.AbstractChart

- All Implemented Interfaces:
    com.twosigma.beakerx.widget.CommFunctionality, com.twosigma.beakerx.widget.DisplayableWidget, com.twosigma.beakerx.widget.WidgetItem
  Direct Known Subclasses:
    CategoryPlot, HeatMap, Histogram, XYChart

      public abstract class AbstractChart
      extends Chart

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.twosigma.beakerx.widget.Widget

      `com.twosigma.beakerx.widget.Widget.ActionPerformed, com.twosigma.beakerx.widget.Widget.WidgetDisplayMethodStrategy`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected java.util.TimeZone` | `timeZone`
    `protected YAxis` | `yAxis`

    - ### Fields inherited from class com.twosigma.beakerx.chart.Chart

      `PLOT_GRIDLINE, PLOT_LABEL, PLOT_LABEL_X, PLOT_LABEL_Y, PLOT_TITLE`

    - ### Fields inherited from class com.twosigma.beakerx.widget.BeakerxWidget

      `MODEL, MODEL_MODULE_VALUE, MODEL_UPDATE, VIEW_MODULE_VALUE`

    - ### Fields inherited from class com.twosigma.beakerx.widget.Widget

      `APPLICATION_VND_JUPYTER_WIDGET_VIEW_JSON, DESCRIPTION, DISABLED, DISPLAY, INDEX, METHOD, MODEL_ID, MODEL_MODULE, MODEL_MODULE_VERSION, MODEL_MODULE_VERSION_VALUE, MODEL_NAME, MSG_THROTTLE, VALUE, VIEW_MODULE, VIEW_MODULE_VERSION, VIEW_MODULE_VERSION_VALUE, VIEW_NAME, VISIBLE`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `AbstractChart()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `AbstractChart` | `add(java.util.List items)`
    `AbstractChart` | `add(YAxis yAxis)`
    `java.lang.Boolean` | `getAutoZoom()`
    `Crosshair` | `getCrosshair()`
    `java.lang.Boolean` | `getLogY()`
    `java.lang.Boolean` | `getOmitCheckboxes()`
    `java.util.TimeZone` | `getTimeZone()`
    `java.lang.String` | `getxLabel()`
    `java.lang.String` | `getXLabel()`
    `double` | `getxLowerMargin()`
    `double` | `getXLowerMargin()`
    `double` | `getxUpperMargin()`
    `double` | `getXUpperMargin()`
    `java.lang.Boolean` | `getyAutoRange()`
    `java.lang.Boolean` | `getYAutoRange()`
    `java.lang.Boolean` | `getyAutoRangeIncludesZero()`
    `java.lang.Boolean` | `getYAutoRangeIncludesZero()`
    `java.util.List<YAxis>` | `getyAxes()`
    `java.util.List<YAxis>` | `getYAxes()`
    `java.lang.String` | `getyLabel()`
    `java.lang.String` | `getYLabel()`
    `java.lang.Double` | `getyLogBase()`
    `java.lang.Double` | `getYLogBase()`
    `java.lang.Double` | `getyLowerBound()`
    `java.lang.Double` | `getYLowerBound()`
    `double` | `getyLowerMargin()`
    `double` | `getYLowerMargin()`
    `java.lang.Double` | `getyUpperBound()`
    `java.lang.Double` | `getYUpperBound()`
    `double` | `getyUpperMargin()`
    `double` | `getYUpperMargin()`
    `AbstractChart` | `leftShift(java.util.List items)`
    `AbstractChart` | `leftShift(YAxis yAxis)`
    `AbstractChart` | `setAutoZoom(boolean autoZoom)`
    `AbstractChart` | `setCrosshair(Crosshair crosshair)`
    `AbstractChart` | `setLogY(boolean logY)`
    `AbstractChart` | `setOmitCheckboxes(boolean omitCheckboxes)`
    `protected AbstractChart` | `setTimeZone(java.util.TimeZone timeZone)`
    `AbstractChart` | `setxLabel(java.lang.String xLabel)`
    `AbstractChart` | `setXLabel(java.lang.String xLabel)`
    `AbstractChart` | `setxLowerMargin(double margin)`
    `AbstractChart` | `setXLowerMargin(double margin)`
    `AbstractChart` | `setxUpperMargin(double margin)`
    `AbstractChart` | `setXUpperMargin(double margin)`
    `AbstractChart` | `setyAutoRange(boolean yAutoRange)`
    `AbstractChart` | `setYAutoRange(boolean yAutoRange)`
    `AbstractChart` | `setyAutoRangeIncludesZero(boolean yAutoRangeIncludesZero)`
    `AbstractChart` | `setYAutoRangeIncludesZero(boolean yAutoRangeIncludesZero)`
    `AbstractChart` | `setYBound(double lower, double upper)`
    `AbstractChart` | `setyBound(java.util.List<java.lang.Number> bound)`
    `AbstractChart` | `setYBound(java.util.List<java.lang.Number> bound)`
    `AbstractChart` | `setyLabel(java.lang.String yLabel)`
    `AbstractChart` | `setYLabel(java.lang.String yLabel)`
    `AbstractChart` | `setyLogBase(double yLogBase)`
    `AbstractChart` | `setYLogBase(double yLogBase)`
    `AbstractChart` | `setyLowerMargin(double margin)`
    `AbstractChart` | `setYLowerMargin(double margin)`
    `AbstractChart` | `setyUpperMargin(double margin)`
    `AbstractChart` | `setYUpperMargin(double margin)`

    - ### Methods inherited from class com.twosigma.beakerx.chart.Chart

      `getCustomStyles, getElementStyles, getGridLineStyle, getInitHeight, getInitWidth, getLabelStyle, getLabelXStyle, getLabelYStyle, getLegendLayout, getLegendPosition, getModelNameValue, getShowLegend, getTitle, getTitleStyle, getUseToolTip, getViewNameValue, serializeToJsonObject, serializeToJsonObject, setCustomStyles, setGridLineStyle, setInitHeight, setInitWidth, setLabelStyle, setLabelXStyle, setLabelYStyle, setLegendLayout, setLegendPosition, setShowLegend, setTitle, setTitleStyle, setUseToolTip`

    - ### Methods inherited from class com.twosigma.beakerx.chart.ChartDetails

      `getDetails, getDetailsFromMessage, getGraphics, getGraphicsById, getGraphicsUid, onActionDetails, openComm, setDetails, updateDetails`

    - ### Methods inherited from class com.twosigma.beakerx.widget.BeakerxWidget

      `activateWidgetInContainer, addValueChangeMsgCallback, beforeDisplay, content, getModelModuleValue, getViewModuleValue, sendModel, sendModelUpdate, sendModelUpdate`

    - ### Methods inherited from class com.twosigma.beakerx.widget.Widget

      `asWidget, close, display, getComm, getModelModuleVersion, getViewModuleVersion, handleCommEventSync, openComm, sendDisplay, sendUpdate, sendUpdate, sendUpdate`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### yAxis

          protected final YAxis yAxis

    - #### timeZone

          protected java.util.TimeZone timeZone

  - ### Constructor Detail

    - #### AbstractChart

          protected AbstractChart()

  - ### Method Detail

    - #### setXLabel

          public AbstractChart setXLabel(java.lang.String xLabel)

    - #### setxLabel

          public AbstractChart setxLabel(java.lang.String xLabel)

    - #### getXLabel

          public java.lang.String getXLabel()

    - #### getxLabel

          public java.lang.String getxLabel()

    - #### setYLabel

          public AbstractChart setYLabel(java.lang.String yLabel)

    - #### setyLabel

          public AbstractChart setyLabel(java.lang.String yLabel)

    - #### getYLabel

          public java.lang.String getYLabel()

    - #### getyLabel

          public java.lang.String getyLabel()

    - #### add

          public AbstractChart add(YAxis yAxis)

    - #### leftShift

          public AbstractChart leftShift(YAxis yAxis)

    - #### getYAxes

          public java.util.List<YAxis> getYAxes()

    - #### getyAxes

          public java.util.List<YAxis> getyAxes()

    - #### add

          public AbstractChart add(java.util.List items)

    - #### leftShift

          public AbstractChart leftShift(java.util.List items)

    - #### setXLowerMargin

          public AbstractChart setXLowerMargin(double margin)

    - #### setxLowerMargin

          public AbstractChart setxLowerMargin(double margin)

    - #### getXLowerMargin

          public double getXLowerMargin()

    - #### getxLowerMargin

          public double getxLowerMargin()

    - #### setXUpperMargin

          public AbstractChart setXUpperMargin(double margin)

    - #### setxUpperMargin

          public AbstractChart setxUpperMargin(double margin)

    - #### getXUpperMargin

          public double getXUpperMargin()

    - #### getxUpperMargin

          public double getxUpperMargin()

    - #### setyAutoRange

          public AbstractChart setyAutoRange(boolean yAutoRange)

    - #### setYAutoRange

          public AbstractChart setYAutoRange(boolean yAutoRange)

    - #### getyAutoRange

          public java.lang.Boolean getyAutoRange()

    - #### getYAutoRange

          public java.lang.Boolean getYAutoRange()

    - #### setYAutoRangeIncludesZero

          public AbstractChart setYAutoRangeIncludesZero(boolean yAutoRangeIncludesZero)

    - #### setyAutoRangeIncludesZero

          public AbstractChart setyAutoRangeIncludesZero(boolean yAutoRangeIncludesZero)

    - #### getYAutoRangeIncludesZero

          public java.lang.Boolean getYAutoRangeIncludesZero()

    - #### getyAutoRangeIncludesZero

          public java.lang.Boolean getyAutoRangeIncludesZero()

    - #### setYLowerMargin

          public AbstractChart setYLowerMargin(double margin)

    - #### setyLowerMargin

          public AbstractChart setyLowerMargin(double margin)

    - #### getYLowerMargin

          public double getYLowerMargin()

    - #### getyLowerMargin

          public double getyLowerMargin()

    - #### setYUpperMargin

          public AbstractChart setYUpperMargin(double margin)

    - #### setyUpperMargin

          public AbstractChart setyUpperMargin(double margin)

    - #### getYUpperMargin

          public double getYUpperMargin()

    - #### getyUpperMargin

          public double getyUpperMargin()

    - #### setYBound

          public AbstractChart setYBound(double lower,
                                         double upper)

    - #### setYBound

          public AbstractChart setYBound(java.util.List<java.lang.Number> bound)

    - #### setyBound

          public AbstractChart setyBound(java.util.List<java.lang.Number> bound)

    - #### getYLowerBound

          public java.lang.Double getYLowerBound()

    - #### getyLowerBound

          public java.lang.Double getyLowerBound()

    - #### getYUpperBound

          public java.lang.Double getYUpperBound()

    - #### getyUpperBound

          public java.lang.Double getyUpperBound()

    - #### setLogY

          public AbstractChart setLogY(boolean logY)

    - #### getLogY

          public java.lang.Boolean getLogY()

    - #### setYLogBase

          public AbstractChart setYLogBase(double yLogBase)

    - #### setyLogBase

          public AbstractChart setyLogBase(double yLogBase)

    - #### getYLogBase

          public java.lang.Double getYLogBase()

    - #### getyLogBase

          public java.lang.Double getyLogBase()

    - #### setTimeZone

          protected AbstractChart setTimeZone(java.util.TimeZone timeZone)

    - #### getTimeZone

          public java.util.TimeZone getTimeZone()

    - #### setCrosshair

          public AbstractChart setCrosshair(Crosshair crosshair)

    - #### getCrosshair

          public Crosshair getCrosshair()

    - #### getOmitCheckboxes

          public java.lang.Boolean getOmitCheckboxes()

    - #### setOmitCheckboxes

          public AbstractChart setOmitCheckboxes(boolean omitCheckboxes)

    - #### getAutoZoom

          public java.lang.Boolean getAutoZoom()

    - #### setAutoZoom

          public AbstractChart setAutoZoom(boolean autoZoom)